#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "song.h"
#include "songout.h"

static FILE *output;
static char *HREF;

static int language;/*1 html, 5 txt*/

#define MAXWORD 	30

#define MAXLINE 81
#define MAXOUT MAXLINE+30
#define INDENT " > "


static char line[MAXOUT]; /*null terminated*/
static char chords[MAXLINE]; /*piena di spazi*/
static int pos,chordx,linex;
	/*line[pos]='\0', ultimo carattere di line
	linex dice la lunghezza in output di line,
	chordx e' la posizione=lunghezza di chords*/
static int is_chord,is_strum;
static int nlines;

static void (*more)(void); /* funzione da chiamare per il cambio pagina */

static char *html_acc[]={"'acute","`grave","\"uml","^circ","~tilde",",cedil",NULL};
#ifdef DOS
static char *acc[]={
	" aeiouAEIOUnNcC",
	"`\x85\x8A\x8D\x95\x97         ",
	"'\xA0\x82\xA1\xA2\xA3 \x90       ",
	"\" \x89\x8B\x94\x81\x8e  \x99\x9A     ",
	"^\x83\x88\x8C\x93\x96         ",
	"~          \xA4\xA5  ",
	",            \x87\x80",
	""};
#endif
#ifdef UNIX
char *acc[]={" ",NULL};
#endif

char* word_to_string(char *s,char *ctrl,int *n,int *l)
{
  static char buf[MAXWORD];
  int i,j,x,y;
  for(i=0,j=0,*l=0;s[j]!='\0' && s[j]!=' ' && i+2<MAXWORD;)
    {
      switch(ctrl[j])
	{
	case ' ':
	  buf[i++]=s[j++];
	  (*l)++;
	  break;
	case '&':
	  error("interno #2351");
	  break;
	default: /*un accento*/
	  if (language==1)
	    {
	      for (x=0;html_acc[x]!=NULL && html_acc[x][0]!=ctrl[j];x++);
	      if (html_acc[x]==NULL)
		error("interno #9158");
	      sprintf(buf+i,"&%c%s;",s[j],html_acc[x]+1);
	      i+=2+strlen(html_acc[x]);
	      j++;
	      (*l)++;
	    }
	  else
	    {
	      for (x=1;acc[x]!=NULL && acc[x][0]!=ctrl[j];x++);
	      for (y=1;acc[0][y]!='\0' && acc[0][y]!=s[j];y++);
	      if (acc[x]!=NULL && acc[0][y]==s[j] && acc[x][y]!=' ')
		{
		  buf[i++]=acc[x][y];
		  j++;
		  (*l)++;
		}
	      else
		{
		  buf[i++]=s[j];
		  buf[i++]=ctrl[j++];
		  (*l)+=2;
		}
	    }
	  break;
	}
    }
  buf[i]='\0';
  *n=j;
  return buf;
}

void clr_line(void)
	{
	int i;
	for (i=0;i<MAXLINE-1;i++)
		chords[i]=' ';
	chords[i]='\0';
	line[0]='\0';
	pos=0;
	chordx=linex=0;
	}

void out_out(void)
	{
	int i;
	for (i=MAXLINE-1;i>0 && chords[i-1]==' ';i--);
	if (i>0)
		{
		chords[i]='\0';
 		fprintf(output,"%s\n",chords);
		nlines++;
		}
	fprintf(output,"%s\n",line);
	nlines++;
	if (more!=NULL && nlines>21)
		{
		(*more)();
		nlines=0;
		}
	clr_line();
	}
void out_string(char *s,int n) /*n e' la lunghezza in output*/
	{
	int i;
	if (is_chord && !is_strum)
		{
		if (chordx<linex) chordx=linex;
		if (chordx+n>=MAXLINE-1)
			{
			out_out();
			strcpy(line,INDENT);
			pos=linex=chordx=strlen(line);
			}
		for (i=0;s[i]!='\0';i++)
			{
			if (chordx<MAXLINE-1)
				chords[chordx++]=s[i];
			}
		}
	else
		{
		if (linex+n>=MAXLINE-1)
			{
			out_out();
			strcpy(line,INDENT);
			pos=linex=chordx=strlen(line);
			}
		for (i=0;s[i]!='\0';i++)
			{
			if (pos<MAXOUT-1)
				line[pos++]=s[i];
			}
		line[pos]='\0';
		linex+=n;
		}
	}

void out_voice(void)
{
  out_string(" ",1);
  while (linex<MAXLINE/2)
    out_string(" ",1);
}

void out_line(struct line *p)
{
  int i;
  int n,l;
  char *s;
  if (p->ctrl[0]=='&')
    out_voice();
  else
    {
      for (i=0;p->s[i]!='\0';)
	{
	  s=word_to_string(p->s+i,p->ctrl+i,&n,&l);
	  i+=n;
	  out_string(s,l);
	  if (p->s[i]==' ')
	    {
	      out_string(" ",1);
	      i++;
	    }
	}
    }
}
void out_line_cont(struct line *p)
	{
	int i;
	int n,l;
	char *s;
	for (i=0;p->s[i]!='\0';)
		{
		s=word_to_string(p->s+i,p->ctrl+i,&n,&l);
		i+=n;
		out_string(s,l);
		if (p->s[i]==' ')
			{
			out_string(" ",1);
			i++;
			}
		}
  fprintf(output,"%s",line);
  clr_line();
	}

void out_phrase(struct phrase *p)
	{
	for (;p!=NULL;p=p->next)
		{
		switch(p->level)
			{
			case 1:
				is_chord=1;
				break;
			case 2:
				is_strum++;
				out_string("[",1);
				break;
			case 3:
				is_strum++;
				break;
			}
		if (p->p)
			out_phrase(p->p);
		else
			out_line(p->l);
		switch(p->level)
			{
			case 1:
				is_chord=0;
				break;
			case 2:
				is_strum--;
				out_string("]",1);
				break;
			case 3:
				is_strum--;
				break;
			}
		}
	}
void out_verse(struct verse *p)
	{
	for (;p!=NULL;p=p->next)
		{
		out_phrase(p->list);
		out_out();
		}
      }
void out_part(struct part *p)
{
  for (;p!=NULL;p=p->next)
    {
      if (language==1 && p->type==0)
	fprintf(output,"<em>");
      out_out();
      out_verse(p->list);
      if (language==1 && p->type==0)
	fprintf(output,"</em>");
    }
}
void out_titles(struct song *p)
{
  struct author *a;
  if (p->head.l)
    {
		  if (language==1)
		    fprintf(output,"<H2>");
		out_line(p->head.l);
		out_out();
		  if (language==1)
		    fprintf(output,"</H2>");
		}
	if (p->author)
		{
		  if (language==1)
		    fprintf(output,"<H3>");
		  else
		    out_string("(",1);
		out_line(p->author->name);
		for (a=p->author->next;a!=NULL;a=a->next)
			{
			out_string(", ",2);
			out_line(a->name);
			}
		  if (language!=1)
		    out_string(")",1);
		  out_out();
		  if (language==1)
		    fprintf(output,"</H3>");
		}
	if (p->file)
	  {
	    if (language==1)
	      {
		if (HREF)
		  fprintf(output,
			  "<H4> file: <A HREF=\"%sVOID=%s;search=;\">%s</A></H4>",
			  HREF,p->file->name,p->file->name);
		else
		  fprintf(output,"<H4> source: %s</H4>\n",p->file->name);
	      }
	    else
	      fprintf(output,"source: %s\n",p->file->name);
	  }
	}
void out_song(struct song *p)
	{
	nlines=0;
	rereadsong(p);
	clr_line();
	out_titles(p);
	if (language==1)
	  fprintf(output,"<PRE>");
	out_part(p->main);
	if (language==1)
	  fprintf(output,"</PRE>");
	freemain(p);
	}
void out_songs(struct song_list *p,FILE *fp)
  {
  language=5;
  output=fp;
  more=NULL;
  for (;p!=NULL;p=p->next)
    {
      out_song(p->first);
      fprintf(output,"\n\n");
    }
  }
void out_songs_html(struct song_list *p,FILE *fp)
{
  language=1;
  output=fp;
  more=NULL;
  for(;p!=NULL;p=p->next)
    out_song(p->first);
}
void out_songs_src(struct song_list *p, FILE *fp)
{
  for (;p!=NULL;p=p->next)
    {
    writesource(p->first,fp);
    }
}
void out_song_con(struct song *p,void (*f)(void))
{
  language=5;
  output=stdout;
  more=f;
  out_song(p);
  (*more)();
}
STRING htmlconv(STRING s)
  {
  char *p;
  if (s.s!=NULL)
    {
      for (p=s.s;*p!='\0';p++)
	if (*p==' ' || *p=='&' || *p==';') *p='+';
    }
  return s;
  }

int is_format(char *s,char *format)
{
  char *p;
  for (;*format!='\0';format++)
    {
      p=strchr(s,'%');
      if (p==NULL || *(p+1)!=*format) return 0;
      s=p+2;
    }
  return strchr(s,'%')==NULL;
}

void out_index_titles(struct song *p,int n)
{
  struct author *a;
  struct info *h;
  STRING s;
  fprintf(output,"%d) ",n);
  if (language==1 && HREF!=NULL)
    {
      fprintf(output,"<A HREF=\"");
      if (is_format(HREF,"ss"))
	  {
	    s=song_key(p);
	    s=htmlconv(s);
	    fprintf(output,HREF,p->file->name,s.s);
	    delete_string(s);
	  }
      else
	fprintf(output,"%s",HREF);
      fprintf(output,"\">");
      }
  out_line_cont(p->head.l);
  if (p->author)
    {
      fprintf(output," (");
      out_line_cont(p->author->name);
      for (a=p->author->next;a!=NULL;a=a->next)
	{
	  fprintf(output,", ");
	  out_line_cont(a->name);
	}
      fprintf(output,")");
    }
  for (h=p->head.next;h!=NULL;h=h->next)
    {
    fprintf(output,", %s: ",head_name(h->type));
    out_line_cont(h->l);
    }
  if (language==1)
     {
     if (HREF!=NULL)
        fprintf(output,"</A>");
     fprintf(output,"<BR>\n");
     }
  else
    fprintf(output,"\n");
  nlines++;
}

void out_one_author(int i,struct author *p)
{
  char c;
  STRING S;
  char *s;
  
  if (language==1 && HREF!=NULL)
    {
      fprintf(output,"<A HREF=\"");
      if (is_format(HREF,"s"))
	{
	  S=author_key(p);
	  S=htmlconv(S);
	  fprintf(output,HREF,S.s);
	  delete_string(S);
	}
      else
	fprintf(output,"%s",HREF);
      fprintf(output,"\">");
    }
  s=surname(p->name->s);
  fprintf(output,"%d) %s",i,s);
  if (s!=p->name->s)
    {
      c=*(s-1);
      *(s-1)='\0';
      fprintf(output," (%s)",p->name->s);
      *(s-1)=c;
    }
  if (language==1)
    {
      if (HREF!=NULL)
	fprintf(output,"</A>");
      fprintf(output,"<BR>");
    }
  fprintf(output,"\n");
  
}
void my_out_authors(void)
{
  int i;
  struct author *p;
  for (i=1,p=biblio;p!=NULL;i++,p=p->next)
    {
      out_one_author(i,p);
    }
}
void out_authors(FILE *fp)
{
  output=fp;
  language=5;
  more=NULL;
  my_out_authors();
}
void out_authors_html(FILE *fp)
{
  output=fp;
  language=1;
  more=NULL;
  my_out_authors();
}
void out_authors_con(void (*f)(void))
{
  output=stdout;
  language=1;
  more=f;
  my_out_authors();
}
void out_index(FILE *fp,struct song_list *p)
  {
  int i;
  output=fp;
  more=NULL;
  language=5;
  for (i=0;p!=NULL;p=p->next,i++)
    {
      out_index_titles(p->first,i+1);
    }
  }
void out_index_html(FILE *fp,struct song_list *p)
  {
  int i;
  output=fp;
  language=1;
  more=NULL;
  for (i=0;p!=NULL;p=p->next,i++)
      {
      out_index_titles(p->first,i+1);
      }
  }

void set_lang(int new)
{
language=new;
}
void set_HREF(char *new)
  {
    HREF=new;
    language=1;
    output=stdout;
  }
